#include "f.hpp"

#include<iostream>
#include <limits>

template<typename T>
void f_cfd(const T& x, T& y, T& dydx) {
  f(x,y);
  T dx=fabs(x)<1 ? sqrt(std::numeric_limits<T>::epsilon())
       : sqrt(std::numeric_limits<T>::epsilon())*fabs(x);
  T yp,ym;
  f(x+dx,yp); f(x-dx,ym); 
  dydx=(yp-ym)/(2*dx);
}

int main() {
  double x=1, y, dydx; 
  f_cfd(x,y,dydx);
  std::cout << y << std::endl
            << dydx << std::endl;
  return 0;
}
