#include "f.hpp"

#include<iostream>
#include <limits>

template<typename T>
void f_cfd(const T& x, T& y, T& dydx) {
  f(x,y);
  T dx=fabs(x)<1 ? sqrt(std::numeric_limits<T>::epsilon())
       : sqrt(std::numeric_limits<T>::epsilon())*fabs(x);
  T yp,ym;
  f(x+dx,yp); f(x-dx,ym); 
  dydx=(yp-ym)/(2*dx);
}

template<typename T>
void f_cfd_cfd(const T& x, T& y, T& dydx, T& ddydxx) {
  f_cfd(x,y,dydx);
  T dx=fabs(x)<1 ? sqrt(sqrt(std::numeric_limits<T>::epsilon()))
       : sqrt(sqrt(std::numeric_limits<T>::epsilon()))*fabs(x);
  T dummy,dydxp,dydxm;
  f_cfd(x+dx,dummy,dydxp); f_cfd(x-dx,dummy,dydxm); 
  ddydxx=(dydxp-dydxm)/(2*dx);
}

int main() {
  double x=1, y, dydx, ddydxx; 
  f_cfd_cfd(x,y,dydx,ddydxx);
  std::cout << y << std::endl
            << dydx << std::endl
            << ddydxx << std::endl;
  return 0;
}
