#include "f.hpp"
#include "dco.hpp"
#include<iostream>

template<typename T>
void f_t(const T& x_v, T& y_v, T& dydx) {
  using DCO_T=typename dco::gt1s<T>::type;
  DCO_T x,y; 
  dco::value(x)=x_v; dco::derivative(x)=1;
  f(x,y);
  y_v=dco::value(y); dydx=dco::derivative(y);
}

template<typename T>
void f_t_t(const T& x_v, T& y_v, T& dydx_v, T& ddydxx) {
  using DCO_T=typename dco::gt1s<T>::type;
  DCO_T x,y,dydx; 
  dco::value(x)=x_v; dco::derivative(x)=1;
  f_t(x,y,dydx);
  y_v=dco::value(y); 
  dydx_v=dco::value(dydx);
  ddydxx=dco::derivative(dydx);
}

int main() {
  double x=1, y, dydx, ddydxx; 
  f_t_t(x,y,dydx,ddydxx);
  std::cout << y << std::endl
            << dydx << std::endl
            << ddydxx << std::endl;
  return 0;
}
